"use strict";
/**
 * @license
 * Copyright 2019 Ludan Stoecklé
 * SPDX-License-Identifier: Apache-2.0
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.compileTemplateToJsString = void 0;
function compileTemplateToJsString(entryTemplate, language, staticFs, rosaeNlgFeatures, exportDefault = false, compileDebug = false) {
    const options = {
        embedResources: true,
        language: language,
        compileDebug: compileDebug,
    };
    if (staticFs != null) {
        options.staticFs = staticFs;
    }
    const compiled = rosaeNlgFeatures.compileFileClient(entryTemplate, options);
    const res = exportDefault ? compiled + `\nexport default template;` : compiled;
    return res;
}
exports.compileTemplateToJsString = compileTemplateToJsString;
//# sourceMappingURL=jsPackager.js.map