"use strict";
/**
 * @license
 * Copyright 2019 Ludan Stoecklé
 * SPDX-License-Identifier: Apache-2.0
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.expandPackagedTemplateJson = void 0;
const fs = require("fs");
const path = require("path");
function expandPackagedTemplateJson(packagedTemplate, destFolder) {
    const templateIds = Object.keys(packagedTemplate.src.templates);
    for (let i = 0; i < templateIds.length; i++) {
        const templateId = templateIds[i];
        const templateContent = packagedTemplate.src.templates[templateId];
        const fileDest = path.join(destFolder, templateId);
        const dir = path.dirname(fileDest);
        //console.log(`for file ${fileDest}, will create ${dir} directory`);
        fs.mkdirSync(dir, { recursive: true });
        fs.writeFileSync(fileDest, templateContent, 'utf8');
    }
}
exports.expandPackagedTemplateJson = expandPackagedTemplateJson;
//# sourceMappingURL=jsonUnpackager.js.map