(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('fs'), require('path')) :
	typeof define === 'function' && define.amd ? define(['fs', 'path'], factory) :
	(global = typeof globalThis !== 'undefined' ? globalThis : global || self, global.rosaenlgPackager = factory(global.fs, global.path));
}(this, (function (fs, path) { 'use strict';

	function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

	var fs__default = /*#__PURE__*/_interopDefaultLegacy(fs);
	var path__default = /*#__PURE__*/_interopDefaultLegacy(path);

	var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

	function getDefaultExportFromCjs (x) {
		return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
	}

	function createCommonjsModule(fn, basedir, module) {
		return module = {
			path: basedir,
			exports: {},
			require: function (path, base) {
				return commonjsRequire(path, (base === undefined || base === null) ? module.path : base);
			}
		}, fn(module, module.exports), module.exports;
	}

	function getDefaultExportFromNamespaceIfPresent (n) {
		return n && Object.prototype.hasOwnProperty.call(n, 'default') ? n['default'] : n;
	}

	function getDefaultExportFromNamespaceIfNotNamed (n) {
		return n && Object.prototype.hasOwnProperty.call(n, 'default') && Object.keys(n).length === 1 ? n['default'] : n;
	}

	function getAugmentedNamespace(n) {
		if (n.__esModule) return n;
		var a = Object.defineProperty({}, '__esModule', {value: true});
		Object.keys(n).forEach(function (k) {
			var d = Object.getOwnPropertyDescriptor(n, k);
			Object.defineProperty(a, k, d.get ? d : {
				enumerable: true,
				get: function () {
					return n[k];
				}
			});
		});
		return a;
	}

	function commonjsRequire () {
		throw new Error('Dynamic requires are not currently supported by @rollup/plugin-commonjs');
	}

	var interfaces = createCommonjsModule(function (module, exports) {
	"use strict";
	/**
	 * @license
	 * Copyright 2019 Ludan Stoecklé
	 * SPDX-License-Identifier: Apache-2.0
	 */
	Object.defineProperty(exports, "__esModule", { value: true });

	});

	var interfaces$1 = /*@__PURE__*/getDefaultExportFromCjs(interfaces);

	var jsPackager = createCommonjsModule(function (module, exports) {
	"use strict";
	/**
	 * @license
	 * Copyright 2019 Ludan Stoecklé
	 * SPDX-License-Identifier: Apache-2.0
	 */
	Object.defineProperty(exports, "__esModule", { value: true });
	exports.compileTemplateToJsString = void 0;
	function compileTemplateToJsString(entryTemplate, language, staticFs, rosaeNlgFeatures, exportDefault = false, compileDebug = false) {
	    const options = {
	        embedResources: true,
	        language: language,
	        compileDebug: compileDebug,
	    };
	    if (staticFs != null) {
	        options.staticFs = staticFs;
	    }
	    const compiled = rosaeNlgFeatures.compileFileClient(entryTemplate, options);
	    const res = exportDefault ? compiled + `\nexport default template;` : compiled;
	    return res;
	}
	exports.compileTemplateToJsString = compileTemplateToJsString;

	});

	var jsPackager$1 = /*@__PURE__*/getDefaultExportFromCjs(jsPackager);

	var jsonPackager = createCommonjsModule(function (module, exports) {
	"use strict";
	/**
	 * @license
	 * Copyright 2019 Ludan Stoecklé
	 * SPDX-License-Identifier: Apache-2.0
	 */
	Object.defineProperty(exports, "__esModule", { value: true });
	exports.completePackagedTemplateJson = void 0;


	const FORMAT = '2.0.0';
	function getFinalFileName(baseDir, template) {
	    const pathElts = path__default['default'].parse(template);
	    const templateWithExt = pathElts.ext == null || pathElts.ext == '' ? template + '.pug' : template;
	    const fullPath = baseDir ? path__default['default'].join(baseDir, templateWithExt) : templateWithExt;
	    const finalFileName = fullPath.replace(new RegExp('\\\\', 'g'), '/'); // change to linux paths
	    return finalFileName;
	}
	const includeRe = new RegExp('^include\\s+(.+)$');
	function getTemplatesMap(baseDir, template, templatesMap) {
	    //console.log('starting to process: ' + template);
	    templatesMap = templatesMap || {};
	    const finalFileName = getFinalFileName(baseDir, template);
	    // console.log('finalFileName is: ' + finalFileName);
	    const content = fs__default['default'].readFileSync(finalFileName, 'utf8');
	    // add this one
	    templatesMap[finalFileName] = content;
	    // check includes
	    const lines = content.split(/\r?\n/);
	    for (let i = 0; i < lines.length; i++) {
	        const line = lines[i];
	        const matches = line.trim().match(includeRe);
	        if (matches && matches[1]) {
	            const matched = matches[1];
	            // console.log('found included: ' + matched);
	            const newBaseDir = path__default['default'].parse(finalFileName).dir;
	            // console.log('newBaseDir: ' + newBaseDir);
	            templatesMap = getTemplatesMap(newBaseDir, matched, templatesMap);
	        }
	    }
	    return templatesMap;
	}
	function completePackagedTemplateJson(packagedTemplate, rosaeNlgFeatures) {
	    packagedTemplate.format = FORMAT;
	    // if templates are not here, we read them from the disk
	    if (!packagedTemplate.src.templates) {
	        packagedTemplate.src.templates = getTemplatesMap(null, packagedTemplate.src.entryTemplate, null);
	    }
	    // compile if asked
	    if (packagedTemplate.src.compileInfo && packagedTemplate.src.compileInfo.activate) {
	        const options = {
	            embedResources: true,
	            language: packagedTemplate.src.compileInfo.language,
	            compileDebug: packagedTemplate.src.compileInfo.compileDebug,
	            staticFs: packagedTemplate.src.templates,
	            // optional forced list elements
	            verbs: packagedTemplate.src.compileInfo.verbs,
	            words: packagedTemplate.src.compileInfo.words,
	            adjectives: packagedTemplate.src.compileInfo.adjectives,
	        };
	        const compiled = rosaeNlgFeatures.compileFileClient(packagedTemplate.src.entryTemplate, options);
	        packagedTemplate.comp = {
	            compiled: compiled,
	            compiledWithVersion: rosaeNlgFeatures.getRosaeNlgVersion(),
	            compiledBy: 'rosaenlg-packager',
	            compiledWhen: new Date().toISOString(),
	        };
	    }
	}
	exports.completePackagedTemplateJson = completePackagedTemplateJson;

	});

	var jsonPackager$1 = /*@__PURE__*/getDefaultExportFromCjs(jsonPackager);

	var jsonUnpackager = createCommonjsModule(function (module, exports) {
	"use strict";
	/**
	 * @license
	 * Copyright 2019 Ludan Stoecklé
	 * SPDX-License-Identifier: Apache-2.0
	 */
	Object.defineProperty(exports, "__esModule", { value: true });
	exports.expandPackagedTemplateJson = void 0;


	function expandPackagedTemplateJson(packagedTemplate, destFolder) {
	    const templateIds = Object.keys(packagedTemplate.src.templates);
	    for (let i = 0; i < templateIds.length; i++) {
	        const templateId = templateIds[i];
	        const templateContent = packagedTemplate.src.templates[templateId];
	        const fileDest = path__default['default'].join(destFolder, templateId);
	        const dir = path__default['default'].dirname(fileDest);
	        //console.log(`for file ${fileDest}, will create ${dir} directory`);
	        fs__default['default'].mkdirSync(dir, { recursive: true });
	        fs__default['default'].writeFileSync(fileDest, templateContent, 'utf8');
	    }
	}
	exports.expandPackagedTemplateJson = expandPackagedTemplateJson;

	});

	var jsonUnpackager$1 = /*@__PURE__*/getDefaultExportFromCjs(jsonUnpackager);

	var dist = createCommonjsModule(function (module, exports) {
	"use strict";
	/**
	 * @license
	 * Copyright 2019 Ludan Stoecklé
	 * SPDX-License-Identifier: Apache-2.0
	 */
	var __createBinding = (commonjsGlobal && commonjsGlobal.__createBinding) || (Object.create ? (function(o, m, k, k2) {
	    if (k2 === undefined) k2 = k;
	    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
	}) : (function(o, m, k, k2) {
	    if (k2 === undefined) k2 = k;
	    o[k2] = m[k];
	}));
	var __exportStar = (commonjsGlobal && commonjsGlobal.__exportStar) || function(m, exports) {
	    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
	};
	Object.defineProperty(exports, "__esModule", { value: true });
	exports.expandPackagedTemplateJson = exports.completePackagedTemplateJson = exports.compileTemplateToJsString = void 0;
	__exportStar(interfaces, exports);

	Object.defineProperty(exports, "compileTemplateToJsString", { enumerable: true, get: function () { return jsPackager.compileTemplateToJsString; } });

	Object.defineProperty(exports, "completePackagedTemplateJson", { enumerable: true, get: function () { return jsonPackager.completePackagedTemplateJson; } });

	Object.defineProperty(exports, "expandPackagedTemplateJson", { enumerable: true, get: function () { return jsonUnpackager.expandPackagedTemplateJson; } });
	const jsPackager_2 = jsPackager;
	const jsonPackager_2 = jsonPackager;
	const jsonUnpackager_2 = jsonUnpackager;
	exports.default = {
	    compileTemplateToJsString: jsPackager_2.compileTemplateToJsString,
	    completePackagedTemplateJson: jsonPackager_2.completePackagedTemplateJson,
	    expandPackagedTemplateJson: jsonUnpackager_2.expandPackagedTemplateJson,
	};

	});

	var index = /*@__PURE__*/getDefaultExportFromCjs(dist);

	return index;

})));
